#pragma once
#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <uri/UriBraces.h>
#include <uri/UriRegex.h>
#include "LittleFS.h"
#include "ArduinoJson.h"
#include "UserDb.h"
#include "Rfid.h"
namespace webconsole
{
    static const char path_prefix[] PROGMEM = "/s";
    static ESP8266WebServer _server(80);
    class WebConsole
    {
    public:
        WebConsole();
        ~WebConsole();

        bool init(userdb::UserDb *userdb);
        void attachRfid(Rfid *rfid);
        void serve();
        bool isInterceptingRfid();

    private:
        void _handleUnknown();
        void _getUserDb();
        void _deleteUser();
        void _getUser();
        void _updateUser();
        void _createUser();
        void _dropUserDb();
        void _catchRFID();
        void _updateAdmin();
        void _print_db_raw()
        {
            File f = LittleFS.open("userdb.csv", "r");
            while (f.available()){
                f.sendAvailable(Serial);
            }
            _server->send(200,"text/plain","printed to serial");
            f.close();
        }
        ESP8266WebServer *_server;
        userdb::UserDb *userdb = nullptr;
        bool catch_rfid = false;
        bool catch_rfid_updated = false;
        String rfid_buffer;
        Rfid *rfid = nullptr;
    };

}